#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* walking just increases our current heading by that many paces */
void walk(int paces, int* x, int* y, int dx, int dy) {
    *x += dx * paces;
    *y += dy * paces;
}

/* set our heading based on the way we turn */
void turn(const char* direction, int* dx, int* dy) {
    if (strcmp(direction, "north") == 0) {
        *dx = 0;
        *dy = 1;
    } else if (strcmp(direction, "south") == 0) { 
        *dx = 0;
        *dy = -1;
    } else if (strcmp(direction, "east") == 0) { 
        *dx = 1;
        *dy = 0;
    } else if (strcmp(direction, "west") == 0) { 
        *dx = -1;
        *dy = 0;
    }
}

int main() {
    /* our position and heading - using a system where -x is west, x is east,
     * -y is south and y is north */
    int x = 0, y = 0, dx = 0, dy = 1;
    int n, i;

    /* go through each line */
    scanf("%d\n", &n);
    for (i = 0; i < n; i++) {
        /* read what type it is */
        char instruction[32];
        scanf("%s", instruction);

        /* handle it based on type */
        if (strcmp(instruction, "Walk") == 0) {
            int paces;
            scanf("%d paces\n", &paces);
            walk(paces, &x, &y, dx, dy);
        } else if (strcmp(instruction, "Turn") == 0) {
            char direction[32];
            scanf("%s\n", direction); 
            turn(direction, &dx, &dy);
        }
    }

    /* print the final results */
    printf("Treasure is ");

    if (y) {
        printf("%d paces to the %s", abs(y), y > 0 ? "north" : "south");
    }

    if (y && x) {
        printf(" and ");
    }

    if (x) {
        printf("%d paces to the %s", abs(x), x > 0 ? "east" : "west"); 
    }

    if (!y && !x) {
        printf("right here");
    }

    printf(".\n");

    return 0;
}

