#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

/* compare two double for equality, or as near as dammit */
#define EPSILON .00001
int eq(double a, double b) {
    if (fabs(a - b) < EPSILON) {
        return 1;
    } else {
        return 0;
    }
}

/* returns the next ratio from the input file */
double get_ratio() {
    char op;
    int value;
    scanf("%c %d\n", &op, &value);
    if (op == '*') {
        return value;
    } else {
        return 1.0 / value;
    }
}

/* check if any one of the potions from the input file will restore Alice */
int check_one(double ratio, double* potions, int num, int invalid) {
    for (int i = 0; i < num; i++) {
        /* if this works, and isn't invalid */
        if (eq(ratio * potions[i], 1.0) && i != invalid) {
            return i;
        }
    }

    return -1;
}

int main() {
    /* read in all of the input */
    double ratio = get_ratio();
    int num;
    scanf("%d\n", &num);
    double potions[num];
    for (int i = 0; i < num; i++) {
        potions[i] = get_ratio();
    }

    /* check if one potion will restore her */
    int which = check_one(ratio, potions, num, -1);
    if (which != -1) {
        printf("Alice should drink potion %d.\n", which + 1);
        return 0;
    }

    /* check if two potions will restore her */
    for (int i = 0; i < num; i++) {
        which = check_one(ratio * potions[i], potions, num, i);
        if (which != -1) {
            /* print them in order */
            i++;
            which++;
            printf("Alice should drink potions %d and %d.\n", i < which ? i : which, i < which ? which : i);
            return 0;
        }
    }

    printf("There is no solution.\n");

    return 0;
}

