#include <stdio.h>
#include <stdlib.h>

/* this function returns the maximum sum from a list of recruits */
int maximize(int* recruits, int n, int* memoized) {
    /* if there are no recruits, return 0, if one recruit, return that one */
    if (n == 0) {
        return 0;
    } else if (n == 1) {
        return recruits[0];
    }

    /* if we've memoized this result, reuse it */
    if (memoized[n - 1] != -1) {
        return memoized[n - 1];
    }

    /* we consider whether or not to include the last item if we do, then the
     * best we can do is that item + the best we can do without the item before it */
    int option1 = recruits[n - 1] + maximize(recruits, n - 2, memoized);

    /* if we do not include the last item, then the best we can do is the maximum of
     * the items without that item only */
    int option2 = maximize(recruits, n - 1, memoized);

    /* figure out the best option and memoize it */
    int best = option1 > option2 ? option1 : option2;
    memoized[n - 1] = best;
    return best;
}

int main() {
    int n, i;

    /* read all of the data */
    scanf("%d\n", &n);
    int* recruits = malloc(n * sizeof(int));
    for (i = 0; i < n; i++) {
        scanf("%d\n", &recruits[i]);
    }

    /* create an array for storing the memoized results */
    int* memoized = malloc(n * sizeof(int));
    for (i = 0; i < n; i++) {
        memoized[i] = -1;
    }

    /* calculate the final answer */
    int answer = maximize(recruits, n, memoized);
    printf("The maximum strength of the army is %d.\n", answer);

    free(recruits);
    free(memoized);
    return 0;
}

